#include <QPixmap>

#include "ImageProjector.h"

class MergeEditor :
	public ImageProjector
{
	Q_OBJECT
public:
	MergeEditor(void);
	~MergeEditor(void);

	enum EditMode { None=0, Paint, Erase, Spray };

	void setMask( QBitmap* m );

	void setTheirs( QImage* t );
	void setYours( QImage* y ) { yours = y; };

	void setBrushSize( int px );

	void setEraserColor( QColor c ) { eraserColor = c; };
	void setEraserSize( int px );

	void setMode( EditMode m );

signals:
	void imageEdited();

public slots:
	void nil1() {};
	void setBlend( int alpha );

protected:
	void leaveEvent( QEvent* );
	void mouseMoveEvent( QMouseEvent* e );
	void mousePressEvent( QMouseEvent* e );
	void paintEvent( QPaintEvent* e );

private:
	void eraseImage( int x, int y );
	void paintImage( int x, int y );
	void sprayImage();

	QImage* theirs;
	QImage* yours;
	QPixmap texture;
	
	QImage scratch;
	QImage s_alpha;

	EditMode mode;
	QColor brushColor;
	int brushSize;

	QColor eraserColor;
	int eraserSize;

	QPoint mouseCoord;

	QRegion stencil;
};
